/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package mechacrawler;

import java.io.*;
import java.util.*;
import java.util.concurrent.*;
import java.net.*;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author isaaclw
 */
public class Crawler implements Runnable {

    private UrlScanner url;
    private WordScanner word;
    private static BlockingQueue<URL> queue;
    private MechStore database;
    private String wordPattern;
    private String domainRegex;
    private URL start;

    public static void main(String args[]) throws MalformedURLException, IOException {
        new Crawler(new URL("http://www.goshen.edu/"), "http://www.goshen.edu/", "[a-zA-Z]{4,}", new MechStore());
    }

    public Crawler(URL theStart, String domain, String regex, MechStore store) throws MalformedURLException, IOException {
        database = store;
        domainRegex = domain;
        wordPattern = regex;
        queue = new LinkedBlockingQueue<URL>();
        start = theStart;
        

    }

    public static synchronized void add(URL aUrl) throws MalformedURLException, InterruptedException {
        queue.put(aUrl);
//        System.out.println("added " + aUrl.getPath());
    }

    public void run() {
        //start the first scan from base url
        try {
            newScan(start);
            
        } catch (MalformedURLException ex) {
            Logger.getLogger(Crawler.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Crawler.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        while (MechaWar.running()) {
            try {
                if ((url.isDone()) && (word.isDone())) {
                    // take one out of the queue
                    URL next = queue.take();
                    newScan(next);

                } else {
                    Thread.sleep(10);
                }
            } catch (InterruptedException ex) {
                Logger.getLogger(Crawler.class.getName()).log(Level.SEVERE, null, ex);
            } catch (MalformedURLException ex) {
                Logger.getLogger(Crawler.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IOException ex) {
                Logger.getLogger(Crawler.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
    //start a new scan
    private void newScan(URL next) throws MalformedURLException, IOException {
        url = new UrlScanner(next, domainRegex, database);
        word = new WordScanner(next, wordPattern, database);

        Thread urlThread = new Thread(url);
        Thread wordThread = new Thread(word);

        urlThread.start();
        wordThread.start();
    }
}
