/*
 * MechaWar.java
 *
 * Created on March 3, 2009, 9:00 PM
 */
package mechacrawler;

import java.io.*;
import java.util.*;
import java.util.concurrent.*;
import java.net.*;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author  danieltv
 */
public class MechaWar extends javax.swing.JFrame {

    private static Crawler crawl;
    private static MechStore storage;
    private static boolean running = false;

    /** Creates new form MechaWar */
    public MechaWar() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        craPanel = new javax.swing.JPanel();
        craButton = new javax.swing.JButton();
        urlButton = new javax.swing.JButton();
        craScrollPanel = new javax.swing.JScrollPane();
        craDisp = new javax.swing.JTextArea();
        initLabel = new javax.swing.JLabel();
        worLabel = new javax.swing.JLabel();
        craLabel = new javax.swing.JLabel();
        domLabel = new javax.swing.JLabel();
        domField = new javax.swing.JTextField();
        worField = new javax.swing.JTextField();
        initField = new javax.swing.JTextField();
        disButton = new javax.swing.JButton();
        seaPanel = new javax.swing.JPanel();
        seaScrollPanel = new javax.swing.JScrollPane();
        seaDisp = new javax.swing.JTextArea();
        seaField = new javax.swing.JTextField();
        pageSearch = new javax.swing.JButton();
        occSearch = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Mecha Crawler");

        craPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Crawler"));

        craButton.setText("Crawl");
        craButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                craButtonActionPerformed(evt);
            }
        });

        urlButton.setText("Display URL");
        urlButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                urlButtonActionPerformed(evt);
            }
        });

        craDisp.setColumns(20);
        craDisp.setEditable(false);
        craDisp.setRows(5);
        craScrollPanel.setViewportView(craDisp);

        initLabel.setText("Initial Web Page");

        worLabel.setText("Word Restriction");

        craLabel.setText("0");
        craLabel.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        domLabel.setText("Domain Restriction");

        domField.setText("http://www.goshen.edu/");

        worField.setText("[a-zA-Z]{4,}");
        worField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                worFieldActionPerformed(evt);
            }
        });

        initField.setText("http://www.goshen.edu/");

        disButton.setText("Display Words");
        disButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                disButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout craPanelLayout = new javax.swing.GroupLayout(craPanel);
        craPanel.setLayout(craPanelLayout);
        craPanelLayout.setHorizontalGroup(
            craPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(craPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(craPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(urlButton, javax.swing.GroupLayout.DEFAULT_SIZE, 94, Short.MAX_VALUE)
                    .addComponent(craButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 94, Short.MAX_VALUE)
                    .addComponent(initLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 94, Short.MAX_VALUE)
                    .addComponent(domLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 94, Short.MAX_VALUE)
                    .addComponent(worLabel, javax.swing.GroupLayout.Alignment.LEADING))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(craPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(disButton, javax.swing.GroupLayout.DEFAULT_SIZE, 440, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, craPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(craLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(initField, javax.swing.GroupLayout.DEFAULT_SIZE, 435, Short.MAX_VALUE)
                        .addComponent(domField)
                        .addComponent(worField)))
                .addContainerGap())
            .addComponent(craScrollPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 560, Short.MAX_VALUE)
        );
        craPanelLayout.setVerticalGroup(
            craPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(craPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(craPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(initLabel)
                    .addComponent(initField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(craPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(domLabel)
                    .addComponent(domField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(craPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(worLabel)
                    .addComponent(worField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(craPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(craButton)
                    .addComponent(craLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(craPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(urlButton)
                    .addComponent(disButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(craScrollPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 435, Short.MAX_VALUE))
        );

        seaPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Web Search"));

        seaDisp.setColumns(20);
        seaDisp.setEditable(false);
        seaDisp.setRows(5);
        seaScrollPanel.setViewportView(seaDisp);

        seaField.setText("Witmer");

        pageSearch.setText("Search by Page Count");
        pageSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pageSearchActionPerformed(evt);
            }
        });

        occSearch.setText("Search by Occurrance Count");
        occSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                occSearchActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout seaPanelLayout = new javax.swing.GroupLayout(seaPanel);
        seaPanel.setLayout(seaPanelLayout);
        seaPanelLayout.setHorizontalGroup(
            seaPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(seaScrollPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
            .addGroup(seaPanelLayout.createSequentialGroup()
                .addComponent(pageSearch)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 96, Short.MAX_VALUE)
                .addComponent(occSearch))
            .addComponent(seaField, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
        );
        seaPanelLayout.setVerticalGroup(
            seaPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(seaPanelLayout.createSequentialGroup()
                .addComponent(seaField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(seaPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(pageSearch)
                    .addComponent(occSearch))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(seaScrollPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 527, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(craPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(seaPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(craPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(seaPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void craButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_craButtonActionPerformed
// Start or Stop Crawling
    if (craButton.getText().equals("Crawl")) {
        craButton.setText("Stop!");
        running = true;
        threadBgn();

    } else {
        craButton.setText("Crawl");
        running = false;
    }

}//GEN-LAST:event_craButtonActionPerformed

private void disButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_disButtonActionPerformed
// display the words found and the number found on each website
    craDisp.setText("");
    storage.displayWords();
}//GEN-LAST:event_disButtonActionPerformed

private void worFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_worFieldActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_worFieldActionPerformed

private void urlButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_urlButtonActionPerformed
//display the urls found thus far and the number of occurrences
    craDisp.setText("");
    storage.displayUrls();
}//GEN-LAST:event_urlButtonActionPerformed

private void occSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_occSearchActionPerformed
// search by occurrance
    seaDisp.setText("");
    storage.occurance(seaField.getText());
}//GEN-LAST:event_occSearchActionPerformed

private void pageSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pageSearchActionPerformed
// search by page count
    seaDisp.setText("");
    storage.supportLinks(seaField.getText());
}//GEN-LAST:event_pageSearchActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MechaWar().setVisible(true);                             
            }
        });
    }
    
    private static void threadBgn(){
        
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                storage = new MechStore();
                try {
                     crawl = new Crawler(new URL(initField.getText()), domField.getText(), worField.getText(), storage);
                    
                    } catch (MalformedURLException ex) {
                         Logger.getLogger(MechaWar.class.getName()).log(Level.SEVERE, null, ex);
                    } catch (IOException ex) {
                         Logger.getLogger(MechaWar.class.getName()).log(Level.SEVERE, null, ex);
            }
               Thread crawlThread = new Thread(crawl);
               crawlThread.start();                            
            }
        });
        
    }
    
    public static boolean running(){
        return running;
    }
    
    public static void appendCraDisp(String s){
        craDisp.append(s + "\n");
    }
    
    public static void appendSeaDisp (String s){
        seaDisp.append(s + "\n");
    }
    
    public static synchronized void addTotal(int n){
        craLabel.setText(n + "");
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton craButton;
    private static javax.swing.JTextArea craDisp;
    private static javax.swing.JLabel craLabel;
    private javax.swing.JPanel craPanel;
    private javax.swing.JScrollPane craScrollPanel;
    private static javax.swing.JButton disButton;
    private static javax.swing.JTextField domField;
    private javax.swing.JLabel domLabel;
    private static javax.swing.JTextField initField;
    private javax.swing.JLabel initLabel;
    private static javax.swing.JButton occSearch;
    private static javax.swing.JButton pageSearch;
    private static javax.swing.JTextArea seaDisp;
    private javax.swing.JTextField seaField;
    private javax.swing.JPanel seaPanel;
    private javax.swing.JScrollPane seaScrollPanel;
    private javax.swing.JButton urlButton;
    private static javax.swing.JTextField worField;
    private javax.swing.JLabel worLabel;
    // End of variables declaration//GEN-END:variables
    
}
