/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package mechacrawler;

import java.io.*;
import java.util.*;
import java.util.concurrent.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.*;
import java.net.*;

/**
 *
 * @author isaaclw
 */
public class UrlScanner implements Runnable {

    private boolean finished = false;
    private InputStreamReader in;
    private URL ourURL;
//    private final String PATTERN2 = "<a\\s+href\\s*=\\s*\"?([^\">]+?)\"?\\s*>";
    private final String PATTERN = "<a\\s+href\\s*=\\s*\"?\\s*([^\">]+?)\"?\\s*>";
    private MechStore database;
    private String domainRegex;

    /**
     * 
     * @param aURL
     * @param regex
     * @param aDatabase
     * @throws java.net.MalformedURLException
     * @throws java.io.IOException
     */
    public UrlScanner(URL aURL, String domain, MechStore aDatabase) throws MalformedURLException, IOException {
        ourURL = aURL;
        database = aDatabase;
        domainRegex = domain;
//        System.out.println("url = " + ourURL + "    domain = " + domainRegex);
        in = new InputStreamReader(ourURL.openStream());
    }

    public boolean isDone() {
        return finished;
    }

    private boolean domainOk(String match) {
        Pattern pattern = Pattern.compile(domainRegex);
        Matcher matcher = pattern.matcher(match);
     //   System.out.println(matcher);
        return matcher.find(); //<# check
    }

    public void run() {
        int ch;

        // read contents into string builder
        StringBuilder input = new StringBuilder();
        try {
            while ((ch = in.read()) != -1) {
                input.append((char) ch);
            }
        } catch (IOException ex) {
            Logger.getLogger(UrlScanner.class.getName()).log(Level.SEVERE, null, ex);
        }

        // search for all occurrences of defined PATTERN
        Pattern pattern = Pattern.compile(PATTERN, Pattern.CASE_INSENSITIVE);
        Matcher matcher = pattern.matcher(input);

        while (matcher.find()) {
            try {
                // pull out the specific html
                String match = matcher.group(1);

                URL urlMatch;

                urlMatch = new URL(ourURL, match);
//                System.out.println("Found a URL: " + urlMatch);

                if (domainOk(urlMatch + "")) {

//                    System.out.println(urlMatch + " followed through because domain was " + (domainOk(match))); //<# test
                    database.assosiate(ourURL, urlMatch); // and add

                   
                }
            } catch (MalformedURLException ex) {
                Logger.getLogger(UrlScanner.class.getName()).log(Level.SEVERE, null, ex);
            } catch (InterruptedException ex) {
                Logger.getLogger(UrlScanner.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        finished = true;
    }
}
