/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package mechacrawler;

import java.io.*;
import java.util.*;
import java.util.concurrent.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.*;
import java.net.*;

/**
 *
 * @author isaaclw
 */
public class WordScanner implements Runnable {

    private boolean finished = false;
    private InputStreamReader in;
    private URL ourURL;
    private String patternString;
    private MechStore database;

    public WordScanner(URL aURL, String regex, MechStore aDatabase) throws MalformedURLException, IOException {
        ourURL = aURL;
        patternString = regex;
        database = aDatabase;
       // System.out.println("url = "+ourURL+"    regex = "+patternString);
        in = new InputStreamReader(ourURL.openStream());
    }

    public boolean isDone() {
        return finished;
    }

    public void run() {
        // read contents into string builder
        StringBuilder input = new StringBuilder();
        int ch;
        try {
            while ((ch = in.read()) != -1) {
                input.append((char) ch);

            // search for all occurrences of pattern
            }
        } catch (IOException ex) {
            Logger.getLogger(WordScanner.class.getName()).log(Level.SEVERE, null, ex);
        }

        Pattern pattern = Pattern.compile(patternString); // The word shouldn't be case sensitive. It should be based off the RegEx
        Matcher matcher = pattern.matcher(input);

        while (matcher.find()) {
            int start = matcher.start();
            int end = matcher.end();
            String match = input.substring(start, end);
            database.addWord(match, ourURL);
        }
        finished = true;
    }
}
